Index: lemon/dim2.h
===================================================================
--- lemon/dim2.h	(revision 314)
+++ lemon/dim2.h	(revision 253)
@@ -260,8 +260,8 @@
 
 
-  /// Bounding box of plain vectors (points).
+  /// Bounding box of plain vectors (\ref Point points).
 
   /// A class to calculate or store the bounding box of plain vectors
-  /// (\ref Point "points").
+  /// (\ref Point points).
   template<typename T>
   class Box {
@@ -574,6 +574,7 @@
   }
 
-  ///Map of x-coordinates of a <tt>Point</tt>-map
-
+  ///Map of x-coordinates of a \ref Point "Point"-map
+
+  ///\ingroup maps
   ///Map of x-coordinates of a \ref Point "Point"-map.
   ///
@@ -592,7 +593,9 @@
   };
 
-  ///Returns an XMap class
-
-  ///This function just returns an XMap class.
+  ///Returns an \ref XMap class
+
+  ///This function just returns an \ref XMap class.
+  ///
+  ///\ingroup maps
   ///\relates XMap
   template<class M>
@@ -608,7 +611,8 @@
   }
 
-  ///Constant (read only) version of XMap
-
-  ///Constant (read only) version of XMap.
+  ///Constant (read only) version of \ref XMap
+
+  ///\ingroup maps
+  ///Constant (read only) version of \ref XMap
   ///
   template<class M>
@@ -625,7 +629,9 @@
   };
 
-  ///Returns a ConstXMap class
-
-  ///This function just returns a ConstXMap class.
+  ///Returns a \ref ConstXMap class
+
+  ///This function just returns a \ref ConstXMap class.
+  ///
+  ///\ingroup maps
   ///\relates ConstXMap
   template<class M>
@@ -635,6 +641,7 @@
   }
 
-  ///Map of y-coordinates of a <tt>Point</tt>-map
-
+  ///Map of y-coordinates of a \ref Point "Point"-map
+
+  ///\ingroup maps
   ///Map of y-coordinates of a \ref Point "Point"-map.
   ///
@@ -653,7 +660,9 @@
   };
 
-  ///Returns a YMap class
-
-  ///This function just returns a YMap class.
+  ///Returns a \ref YMap class
+
+  ///This function just returns a \ref YMap class.
+  ///
+  ///\ingroup maps
   ///\relates YMap
   template<class M>
@@ -669,7 +678,8 @@
   }
 
-  ///Constant (read only) version of YMap
-
-  ///Constant (read only) version of YMap.
+  ///Constant (read only) version of \ref YMap
+
+  ///\ingroup maps
+  ///Constant (read only) version of \ref YMap
   ///
   template<class M>
@@ -686,7 +696,9 @@
   };
 
-  ///Returns a ConstYMap class
-
-  ///This function just returns a ConstYMap class.
+  ///Returns a \ref ConstYMap class
+
+  ///This function just returns a \ref ConstYMap class.
+  ///
+  ///\ingroup maps
   ///\relates ConstYMap
   template<class M>
@@ -697,8 +709,10 @@
 
 
-  ///\brief Map of the normSquare() of a <tt>Point</tt>-map
+  ///\brief Map of the \ref Point::normSquare() "normSquare()"
+  ///of a \ref Point "Point"-map
   ///
   ///Map of the \ref Point::normSquare() "normSquare()"
   ///of a \ref Point "Point"-map.
+  ///\ingroup maps
   template<class M>
   class NormSquareMap
@@ -714,7 +728,9 @@
   };
 
-  ///Returns a NormSquareMap class
-
-  ///This function just returns a NormSquareMap class.
+  ///Returns a \ref NormSquareMap class
+
+  ///This function just returns a \ref NormSquareMap class.
+  ///
+  ///\ingroup maps
   ///\relates NormSquareMap
   template<class M>
Index: lemon/error.h
===================================================================
--- lemon/error.h	(revision 291)
+++ lemon/error.h	(revision 212)
@@ -36,15 +36,144 @@
   /// @{
 
-  /// \brief Generic exception class.
+  /// \brief Exception safe wrapper class.
   ///
+  /// Exception safe wrapper class to implement the members of exceptions.
+  template <typename _Type>
+  class ExceptionMember {
+  public:
+    typedef _Type Type;
+
+    ExceptionMember() throw() {
+      try {
+        ptr.reset(new Type());
+      } catch (...) {}
+    }
+
+    ExceptionMember(const Type& type) throw() {
+      try {
+        ptr.reset(new Type());
+        if (ptr.get() == 0) return;
+        *ptr = type;
+      } catch (...) {}
+    }
+
+    ExceptionMember(const ExceptionMember& copy) throw() {
+      try {
+        if (!copy.valid()) return;
+        ptr.reset(new Type());
+        if (ptr.get() == 0) return;
+        *ptr = copy.get();
+      } catch (...) {}
+    }
+
+    ExceptionMember& operator=(const ExceptionMember& copy) throw() {
+      if (ptr.get() == 0) return;
+      try {
+        if (!copy.valid()) return;
+        *ptr = copy.get();
+      } catch (...) {}
+    }
+
+    void set(const Type& type) throw() {
+      if (ptr.get() == 0) return;
+      try {
+        *ptr = type;
+      } catch (...) {}
+    }
+
+    const Type& get() const {
+      return *ptr;
+    }
+
+    bool valid() const throw() {
+      return ptr.get() != 0;
+    }
+
+  private:
+    std::auto_ptr<_Type> ptr;
+  };
+
+  /// Exception-safe convenient error message builder class.
+
+  /// Helper class which provides a convenient ostream-like (operator <<
+  /// based) interface to create a string message. Mostly useful in
+  /// exception classes (therefore the name).
+  class ErrorMessage {
+  protected:
+    ///\e
+
+    ///\todo The good solution is boost::shared_ptr...
+    ///
+    mutable std::auto_ptr<std::ostringstream> buf;
+
+    ///\e
+    bool init() throw() {
+      try {
+        buf.reset(new std::ostringstream);
+      }
+      catch(...) {
+        buf.reset();
+      }
+      return buf.get();
+    }
+
+  public:
+
+    ///\e
+    ErrorMessage() throw() { init(); }
+
+    ErrorMessage(const ErrorMessage& em) throw() : buf(em.buf) { }
+
+    ///\e
+    ErrorMessage(const char *msg) throw() {
+      init();
+      *this << msg;
+    }
+
+    ///\e
+    ErrorMessage(const std::string &msg) throw() {
+      init();
+      *this << msg;
+    }
+
+    ///\e
+    template <typename T>
+    ErrorMessage& operator<<(const T &t) throw() {
+      if( ! buf.get() ) return *this;
+
+      try {
+        *buf << t;
+      }
+      catch(...) {
+        buf.reset();
+      }
+      return *this;
+    }
+
+    ///\e
+    const char* message() throw() {
+      if( ! buf.get() ) return 0;
+
+      const char* mes = 0;
+      try {
+        mes = buf->str().c_str();
+      }
+      catch(...) {}
+      return mes;
+    }
+
+  };
+
+  /// Generic exception class.
+
   /// Base class for exceptions used in LEMON.
   ///
   class Exception : public std::exception {
   public:
-    ///Constructor
-    Exception() throw() {}
-    ///Virtual destructor
+    ///\e
+    Exception() {}
+    ///\e
     virtual ~Exception() throw() {}
-    ///A short description of the exception
+    ///\e
     virtual const char* what() const throw() {
       return "lemon::Exception";
@@ -52,220 +181,235 @@
   };
 
-  /// \brief Input-Output error
+  /// One of the two main subclasses of \ref Exception.
+
+  /// Logic errors represent problems in the internal logic of a program;
+  /// in theory, these are preventable, and even detectable before the
+  /// program runs (e.g. violations of class invariants).
   ///
-  /// This exception is thrown when a file operation cannot be
-  /// succeeded.
-  class IoError : public Exception {
+  /// A typical example for this is \ref UninitializedParameter.
+  class LogicError : public Exception {
+  public:
+    virtual const char* what() const throw() {
+      return "lemon::LogicError";
+    }
+  };
+
+  /// \ref Exception for uninitialized parameters.
+
+  /// This error represents problems in the initialization
+  /// of the parameters of the algorithms.
+  class UninitializedParameter : public LogicError {
+  public:
+    virtual const char* what() const throw() {
+      return "lemon::UninitializedParameter";
+    }
+  };
+
+
+  /// One of the two main subclasses of \ref Exception.
+
+  /// Runtime errors represent problems outside the scope of a program;
+  /// they cannot be easily predicted and can generally only be caught
+  /// as the program executes.
+  class RuntimeError : public Exception {
+  public:
+    virtual const char* what() const throw() {
+      return "lemon::RuntimeError";
+    }
+  };
+
+  ///\e
+  class RangeError : public RuntimeError {
+  public:
+    virtual const char* what() const throw() {
+      return "lemon::RangeError";
+    }
+  };
+
+  ///\e
+  class IoError : public RuntimeError {
+  public:
+    virtual const char* what() const throw() {
+      return "lemon::IoError";
+    }
+  };
+
+  ///\e
+  class DataFormatError : public IoError {
   protected:
-    std::string _message;
-    std::string _file;
-
-    mutable std::string _what;
-  public:
-
-    /// Copy constructor
-    IoError(const IoError &error) throw() : Exception() {
-      message(error._message);
-      file(error._file);
-    }
-
-    /// Constructor
-    explicit IoError(const char *message) throw() {
-      IoError::message(message);
-    }
-
-    /// Constructor
-    explicit IoError(const std::string &message) throw() {
-      IoError::message(message);
-    }
-
-    /// Constructor
-    explicit IoError(const char *message,
-                     const std::string &file) throw() {
-      IoError::message(message);
-      IoError::file(file);
-    }
-
-    /// Constructor
-    explicit IoError(const std::string &message,
-                     const std::string &file) throw() {
-      IoError::message(message);
-      IoError::file(file);
-    }
-
-    /// Virtual destructor
-    virtual ~IoError() throw() {}
-
-    /// Set the error message
-    void message(const char *message) throw() {
-      try {
-        _message = message;
-      } catch (...) {}
-    }
-
-    /// Set the error message
-    void message(const std::string& message) throw() {
-      try {
-        _message = message;
-      } catch (...) {}
-    }
-
-    /// Set the file name
-    void file(const std::string &file) throw() {
-      try {
-        _file = file;
-      } catch (...) {}
-    }
-
-    /// Returns the error message
-    const std::string& message() const throw() {
-      return _message;
-    }
-
-    /// \brief Returns the filename
+    ExceptionMember<std::string> _message;
+    ExceptionMember<std::string> _file;
+    int _line;
+
+    mutable ExceptionMember<std::string> _message_holder;
+  public:
+
+    DataFormatError(const DataFormatError &dfe) :
+      IoError(dfe), _message(dfe._message), _file(dfe._file),
+      _line(dfe._line) {}
+
+    ///\e
+    explicit DataFormatError(const char *the_message)
+      : _message(the_message), _line(0) {}
+
+    ///\e
+    DataFormatError(const std::string &file_name, int line_num,
+                    const char *the_message)
+      : _message(the_message), _line(line_num) { file(file_name); }
+
+    ///\e
+    void line(int ln) { _line = ln; }
+    ///\e
+    void message(const std::string& msg) { _message.set(msg); }
+    ///\e
+    void file(const std::string &fl) { _file.set(fl); }
+
+    ///\e
+    int line() const { return _line; }
+    ///\e
+    const char* message() const {
+      if (_message.valid() && !_message.get().empty()) {
+        return _message.get().c_str();
+      } else {
+        return 0;
+      }
+    }
+
+    /// \brief Returns the filename.
     ///
-    /// Returns the filename or an empty string if it was not specified.
-    const std::string& file() const throw() {
-      return _file;
-    }
-
-    /// \brief Returns a short error message
+    /// Returns \e null if the filename was not specified.
+    const char* file() const {
+      if (_file.valid() && !_file.get().empty()) {
+        return _file.get().c_str();
+      } else {
+        return 0;
+      }
+    }
+
+    ///\e
+    virtual const char* what() const throw() {
+      try {
+        std::ostringstream ostr;
+        ostr << "lemon:DataFormatError" << ": ";
+        if (message()) ostr << message();
+        if( file() || line() != 0 ) {
+          ostr << " (";
+          if( file() ) ostr << "in file '" << file() << "'";
+          if( file() && line() != 0 ) ostr << " ";
+          if( line() != 0 ) ostr << "at line " << line();
+          ostr << ")";
+        }
+        _message_holder.set(ostr.str());
+      }
+      catch (...) {}
+      if( _message_holder.valid()) return _message_holder.get().c_str();
+      return "lemon:DataFormatError";
+    }
+
+    virtual ~DataFormatError() throw() {}
+  };
+
+  ///\e
+  class FileOpenError : public IoError {
+  protected:
+    ExceptionMember<std::string> _file;
+
+    mutable ExceptionMember<std::string> _message_holder;
+  public:
+
+    FileOpenError(const FileOpenError &foe) :
+      IoError(foe), _file(foe._file) {}
+
+    ///\e
+    explicit FileOpenError(const std::string& fl)
+      : _file(fl) {}
+
+
+    ///\e
+    void file(const std::string &fl) { _file.set(fl); }
+
+    /// \brief Returns the filename.
     ///
-    /// Returns a short error message which contains the message and the
-    /// file name.
-    virtual const char* what() const throw() {
-      try {
-        _what.clear();
-        std::ostringstream oss;
-        oss << "lemon:IoError" << ": ";
-        oss << _message;
-        if (!_file.empty()) {
-          oss << " ('" << _file << "')";
-        }
-        _what = oss.str();
+    /// Returns \e null if the filename was not specified.
+    const char* file() const {
+      if (_file.valid() && !_file.get().empty()) {
+        return _file.get().c_str();
+      } else {
+        return 0;
+      }
+    }
+
+    ///\e
+    virtual const char* what() const throw() {
+      try {
+        std::ostringstream ostr;
+        ostr << "lemon::FileOpenError" << ": ";
+        ostr << "Cannot open file - " << file();
+        _message_holder.set(ostr.str());
       }
       catch (...) {}
-      if (!_what.empty()) return _what.c_str();
-      else return "lemon:IoError";
-    }
-
-  };
-
-  /// \brief Format error
-  ///
-  /// This exception is thrown when an input file has wrong
-  /// format or a data representation is not legal.
-  class FormatError : public Exception {
+      if( _message_holder.valid()) return _message_holder.get().c_str();
+      return "lemon::FileOpenError";
+    }
+    virtual ~FileOpenError() throw() {}
+  };
+
+  class IoParameterError : public IoError {
   protected:
-    std::string _message;
-    std::string _file;
-    int _line;
-
-    mutable std::string _what;
-  public:
-
-    /// Copy constructor
-    FormatError(const FormatError &error) throw() : Exception() {
-      message(error._message);
-      file(error._file);
-      line(error._line);
-    }
-
-    /// Constructor
-    explicit FormatError(const char *message) throw() {
-      FormatError::message(message);
-      _line = 0;
-    }
-
-    /// Constructor
-    explicit FormatError(const std::string &message) throw() {
-      FormatError::message(message);
-      _line = 0;
-    }
-
-    /// Constructor
-    explicit FormatError(const char *message,
-                         const std::string &file, int line = 0) throw() {
-      FormatError::message(message);
-      FormatError::file(file);
-      FormatError::line(line);
-    }
-
-    /// Constructor
-    explicit FormatError(const std::string &message,
-                         const std::string &file, int line = 0) throw() {
-      FormatError::message(message);
-      FormatError::file(file);
-      FormatError::line(line);
-    }
-
-    /// Virtual destructor
-    virtual ~FormatError() throw() {}
-
-    /// Set the line number
-    void line(int line) throw() { _line = line; }
-
-    /// Set the error message
-    void message(const char *message) throw() {
-      try {
-        _message = message;
-      } catch (...) {}
-    }
-
-    /// Set the error message
-    void message(const std::string& message) throw() {
-      try {
-        _message = message;
-      } catch (...) {}
-    }
-
-    /// Set the file name
-    void file(const std::string &file) throw() {
-      try {
-        _file = file;
-      } catch (...) {}
-    }
-
-    /// \brief Returns the line number
+    ExceptionMember<std::string> _message;
+    ExceptionMember<std::string> _file;
+
+    mutable ExceptionMember<std::string> _message_holder;
+  public:
+
+    IoParameterError(const IoParameterError &ile) :
+      IoError(ile), _message(ile._message), _file(ile._file) {}
+
+    ///\e
+    explicit IoParameterError(const char *the_message)
+      : _message(the_message) {}
+
+    ///\e
+    IoParameterError(const char *file_name, const char *the_message)
+      : _message(the_message), _file(file_name) {}
+
+     ///\e
+    void message(const std::string& msg) { _message.set(msg); }
+    ///\e
+    void file(const std::string &fl) { _file.set(fl); }
+
+     ///\e
+    const char* message() const {
+      if (_message.valid()) {
+        return _message.get().c_str();
+      } else {
+        return 0;
+      }
+    }
+
+    /// \brief Returns the filename.
     ///
-    /// Returns the line number or zero if it was not specified.
-    int line() const throw() { return _line; }
-
-    /// Returns the error message
-    const std::string& message() const throw() {
-      return _message;
-    }
-
-    /// \brief Returns the filename
-    ///
-    /// Returns the filename or an empty string if it was not specified.
-    const std::string& file() const throw() {
-      return _file;
-    }
-
-    /// \brief Returns a short error message
-    ///
-    /// Returns a short error message which contains the message, the
-    /// file name and the line number.
-    virtual const char* what() const throw() {
-      try {
-        _what.clear();
-        std::ostringstream oss;
-        oss << "lemon:FormatError" << ": ";
-        oss << _message;
-        if (!_file.empty() || _line != 0) {
-          oss << " (";
-          if (!_file.empty()) oss << "in file '" << _file << "'";
-          if (!_file.empty() && _line != 0) oss << " ";
-          if (_line != 0) oss << "at line " << _line;
-          oss << ")";
-        }
-        _what = oss.str();
+    /// Returns \c 0 if the filename was not specified.
+    const char* file() const {
+      if (_file.valid()) {
+        return _file.get().c_str();
+      } else {
+        return 0;
+      }
+    }
+
+    ///\e
+    virtual const char* what() const throw() {
+      try {
+        std::ostringstream ostr;
+        if (message()) ostr << message();
+        if (file()) ostr << "(when reading file '" << file() << "')";
+        _message_holder.set(ostr.str());
       }
       catch (...) {}
-      if (!_what.empty()) return _what.c_str();
-      else return "lemon:FormatError";
-    }
-
+      if( _message_holder.valid() ) return _message_holder.get().c_str();
+      return "lemon:IoParameterError";
+    }
+    virtual ~IoParameterError() throw() {}
   };
 
Index: lemon/graph_to_eps.h
===================================================================
--- lemon/graph_to_eps.h	(revision 313)
+++ lemon/graph_to_eps.h	(revision 253)
@@ -41,5 +41,4 @@
 #include<lemon/color.h>
 #include<lemon/bits/bezier.h>
-#include<lemon/error.h>
 
 
@@ -63,5 +62,5 @@
   }
 
-///Default traits class of GraphToEps
+///Default traits class of \ref GraphToEps
 
 ///Default traits class of \ref GraphToEps.
@@ -668,4 +667,5 @@
   ///it draws the graph.
   void run() {
+    //\todo better 'epsilon' would be nice here.
     const double EPSILON=1e-9;
     if(dontPrint) return;
@@ -708,4 +708,5 @@
       for(ArcIt e(g);e!=INVALID;++e)
         max_w=std::max(double(_arcWidths[e]),max_w);
+      //\todo better 'epsilon' would be nice here.
       if(max_w>EPSILON) {
         _arcWidthScale/=max_w;
@@ -717,4 +718,5 @@
       for(NodeIt n(g);n!=INVALID;++n)
         max_s=std::max(double(_nodeSizes[n]),max_s);
+      //\todo better 'epsilon' would be nice here.
       if(max_s>EPSILON) {
         _nodeScale/=max_s;
@@ -872,4 +874,5 @@
       }
       else {
+        //\todo Verify centering
         double sc= std::min((A4HEIGHT-2*A4BORDER)/bb.width(),
                   (A4WIDTH-2*A4BORDER)/bb.height());
@@ -904,4 +907,5 @@
             dvec(mycoords[g.target(*i)]-mycoords[g.source(*i)]);
           double l=std::sqrt(dvec.normSquare());
+          //\todo better 'epsilon' would be nice here.
           dim2::Point<double> d(dvec/std::max(l,EPSILON));
           dim2::Point<double> m;
@@ -1168,11 +1172,6 @@
 graphToEps(G &g,const char *file_name)
 {
-  std::ostream* os = new std::ofstream(file_name);
-  if (!(*os)) {
-    delete os;
-    throw IoError("Cannot write file", file_name);
-  }
   return GraphToEps<DefaultGraphToEpsTraits<G> >
-    (DefaultGraphToEpsTraits<G>(g,*os,true));
+    (DefaultGraphToEpsTraits<G>(g,*new std::ofstream(file_name),true));
 }
 
@@ -1189,11 +1188,6 @@
 graphToEps(G &g,const std::string& file_name)
 {
-  std::ostream* os = new std::ofstream(file_name.c_str());
-  if (!(*os)) {
-    delete os;
-    throw IoError("Cannot write file", file_name);
-  }
   return GraphToEps<DefaultGraphToEpsTraits<G> >
-    (DefaultGraphToEpsTraits<G>(g,*os,true));
+    (DefaultGraphToEpsTraits<G>(g,*new std::ofstream(file_name.c_str()),true));
 }
 
